    001    /*
    002     * Copyright (c) 2007-2014 Concurrent, Inc. All Rights Reserved.
    003     *
    004     * Project and contact information: http://www.cascading.org/
    005     *
    006     * This file is part of the Cascading project.
    007     *
    008     * Licensed under the Apache License, Version 2.0 (the "License");
    009     * you may not use this file except in compliance with the License.
    010     * You may obtain a copy of the License at
    011     *
    012     *     http://www.apache.org/licenses/LICENSE-2.0
    013     *
    014     * Unless required by applicable law or agreed to in writing, software
    015     * distributed under the License is distributed on an "AS IS" BASIS,
    016     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017     * See the License for the specific language governing permissions and
    018     * limitations under the License.
    019     */
    020
    021    package cascading.provider;
    022
    023    import cascading.flow.FlowProcess;
    024
    025    /**
    026     * Interface CascadingFactory defines a pluggable "factory" class that can be loaded by the {@link FactoryLoader}
    027     * utility.
    028     * <p/>
    029     * Factory instances are created process side (in a cluster for example) to augment any of the internal strategies.
    030     *
    031     * @see FactoryLoader
    032     */
    033    public interface CascadingFactory<Config, Instance>
    034      {
    035      /**
    036       * Method initialize will configure an initialize this factory instance.
    037       *
    038       * @param flowProcess of type FlowProcess
    039       */
    040      void initialize( FlowProcess<Config> flowProcess );
    041
    042      /**
    043       * Method create will return a new instance of the type create by this factory.
    044       *
    045       * @param flowProcess of type FlowProcess
    046       * @return of type Instance
    047       */
    048      Instance create( FlowProcess<Config> flowProcess );
    049      }